﻿using System.Text;
using HeuristicLab.Algorithms.PushGP.Interpreter;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Exec
{
    public class ExecExpandExpression : Expression
    {
        private const string prefix = "( ";
        private const string postifx = " )";
        private const string delimiter = " ";

        private readonly Expression[] expressions;
        public ExecExpandExpression(Expression[] expressions)
        {
            this.expressions = expressions;
        }

        public override bool IsCodeOp { get { return false; } }

        public override void Eval(IInterpreter interpreter)
        {
            interpreter.ExecStack.Push(this.expressions);
        }

        public override string ToString()
        {
            if (this.expressions.Length == 0)
            {
                return string.Empty;
            }

            var sb = new StringBuilder();
            sb.Append(prefix);

            for (var i = this.expressions.Length - 1; i > 0; i--)
            {
                sb.Append(this.expressions[i] + delimiter);
            }

            sb.Append(this.expressions[0] + postifx);

            return sb.ToString();
        }
    }
}
