﻿using HeuristicLab.Algorithms.PushGP.Interpreter;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Exec
{
    public class ExecYExpression : Expression
    {
        public override bool IsCodeOp { get { return false; } }

        public override void Eval(IInterpreter interpreter)
        {
            // not enough arguments on stack
            if (interpreter.ExecStack.Count == 0)
                return;

            var expandExpression = new ExecExpandExpression(new[]
            {
                interpreter.ExecStack.Top,
                new ExecYExpression()
            });

            interpreter.ExecStack.Insert(interpreter.ExecStack.Count - 1, expandExpression);
        }

        public override string ToString()
        {
            return Symbols.ExecY;
        }
    }
}
