﻿using HeuristicLab.Algorithms.PushGP.Interpreter;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Float
{
    public class FloatPushExpression : Expression
    {
        private readonly double value;
        public FloatPushExpression(double value)
        {
            this.value = value;
        }

        public override bool IsCodeOp { get { return false; } }

        public override void Eval(IInterpreter interpreter)
        {
            interpreter.FloatStack.Push(this.value);
        }

        public override string ToString()
        {
            return this.value.ToString();
        }
    }
}
