﻿namespace HeuristicLab.Algorithms.PushGP.Generators
{
    public class Configuration
    {
        public Configuration()
        {
            this.MinRandomInteger = long.MinValue;
            this.MaxRandomInteger = long.MaxValue;
            this.MinRandomFloat = double.MaxValue;
            this.MaxRandomFloat = double.MaxValue;
            this.NewErcNameProbability = 0.5;
        }

        /// <summary>
        /// The minimum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
        /// </summary>
        public long MinRandomInteger { get; set; }

        /// <summary>
        /// The maximum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
        /// </summary>
        public long MaxRandomInteger { get; set; }

        /// <summary>
        /// The minimum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
        /// </summary>
        public double MinRandomFloat { get; set; }

        /// <summary>
        /// The maximum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
        /// </summary>
        public double MaxRandomFloat { get; set; }

        /// <summary>
        /// The probability that the selection of the ephemeral
        /// random NAME constant for inclusion in randomly generated code will produce a new name
        /// (rather than a name that was previously generated).
        /// </summary>
        public double NewErcNameProbability { get; set; }
    }
}
